
// LineHoughDlg.h : wb_[ t@C
//

#pragma once
#include "afxwin.h"
#include "afxcmn.h"
#include "DlgHoughparam.h"
#include "DlgEdgeparam.h"


// CLineHoughDlg _CAO
class CLineHoughDlg : public CDialogEx
{
// RXgNV
public:
	CLineHoughDlg(CWnd* pParent = NULL);	// WRXgN^[

// _CAO f[^
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_LINEHOUGH_DIALOG };
#endif

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV T|[g


// 
protected:
	HICON m_hIcon;

	// ꂽAbZ[W蓖Ċ֐
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()


	//image
	FVCL::Data::CFvImage m_src;
	FVCL::Data::CFvImage m_dst;
	FVCL::Hough::CFvLineHoughSobelEdge			m_houghsobel;
	FVCL::Hough::CFvLineHoughCorrelationEdge	m_houghcorrelation;

	FVCL::Hough::CFvLineHoughResult             m_result;
	FVCL::Hough::CFvLineHoughParam				m_param;
	FVCL::Edge::CFvEdge2DCorrelationParam		m_correlationparam;	
	FVCL::Edge::CFvEdge2DSobelParam				m_sobelparam;

	CEvView										m_objView;

	CDlgHoughParam								tab_hough;
	CDlgEdgeParam								tab_edge;

	FVCL::GDI::CFvOverlay *m_OverlayEdge;  // I[o[CNX  XP[L
	FVCL::GDI::CFvOverlay *m_OverlayArea;  // I[o[CNX  XP[L
	FVCL::GDI::CFvDisplay m_Display;	   //fBXvC								
	FVCL::CFvTimeCounter m_objTimeCounter; // Ԍv

	bool fnLineHoughPraramSet();
	void fnSetView();
	void fnLineHoughPraramIni();
	bool fnLineHoughExec();
	void fnResultDisplay();
	CBrush m_brGr;
public:
	afx_msg void OnBnClickedButtonLoadImgFile();
	CStatic m_displayzone;
	afx_msg void OnBnClickedButtonDetection();
	afx_msg void OnBnClickedCheckEdgeDisplay();
	afx_msg void OnBnClickedCheckSetArea();
	afx_msg void OnBnClickedCheckAscope();
	afx_msg void OnTcnSelchangeTab(NMHDR *pNMHDR, LRESULT *pResult);
	CTabCtrl m_tab;
	afx_msg void OnBnClickedButtonMag1();
	afx_msg void OnBnClickedButtonFit();
	afx_msg void OnBnClickedButtonPlus();
	afx_msg void OnBnClickedButtonMinus();
	afx_msg void OnBnClickedButtonSaveImage();
	CButton m_disp_edge;
	CListCtrl m_list_result;
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	CString m_strGrabTime;
	afx_msg void OnLvnItemchangedListResult(NMHDR *pNMHDR, LRESULT *pResult);
};
